diff -Nur linux-2.6.9-intc1/fs/jffs2/write.c linux-2.6.9-intc1-mih1/fs/jffs2/write.c
--- linux-2.6.9-intc1/fs/jffs2/write.c	2004-10-18 17:54:08.000000000 -0400
+++ linux-2.6.9-intc1-mih1/fs/jffs2/write.c	2005-03-21 21:28:41.000000000 -0500
@@ -3,11 +3,11 @@
  *
  * Copyright (C) 2001-2003 Red Hat, Inc.
  *
- * Created by David Woodhouse <dwmw2@redhat.com>
+ * Created by David Woodhouse <dwmw2@infradead.org>
  *
  * For licensing information, see the file 'LICENCE' in this directory.
  *
- * $Id: write.c,v 1.85 2004/07/13 08:58:25 dwmw2 Exp $
+ * $Id: write.c,v 1.91 2005/03/01 10:34:03 dedekind Exp $
  *
  */
 
@@ -136,6 +136,15 @@
 	raw->__totlen = PAD(sizeof(*ri)+datalen);
 	raw->next_phys = NULL;
 
+	if ((alloc_mode!=ALLOC_GC) && (je32_to_cpu(ri->version) < f->highest_version)) {
+		BUG_ON(!retried);
+		D1(printk(KERN_DEBUG "jffs2_write_dnode : dnode_version %d, "
+				"highest version %d -> updating dnode\n", 
+				je32_to_cpu(ri->version), f->highest_version));
+		ri->version = cpu_to_je32(++f->highest_version);
+		ri->node_crc = cpu_to_je32(crc32(0, ri, sizeof(*ri)-8));
+	}
+
 	ret = jffs2_flash_writev(c, vecs, cnt, flash_ofs, &retlen,
 				 (alloc_mode==ALLOC_GC)?0:f->inocache->ino);
 
@@ -213,8 +222,10 @@
 	jffs2_add_physical_node_ref(c, raw);
 
 	/* Link into per-inode list */
+	spin_lock(&c->erase_completion_lock);
 	raw->next_in_ino = f->inocache->nodes;
 	f->inocache->nodes = raw;
+	spin_unlock(&c->erase_completion_lock);
 
 	D1(printk(KERN_DEBUG "jffs2_write_dnode wrote node at 0x%08x(%d) with dsize 0x%x, csize 0x%x, node_crc 0x%08x, data_crc 0x%08x, totlen 0x%08x\n",
 		  flash_ofs, ref_flags(raw), je32_to_cpu(ri->dsize), 
@@ -278,6 +289,16 @@
 	raw->__totlen = PAD(sizeof(*rd)+namelen);
 	raw->next_phys = NULL;
 
+	if ((alloc_mode!=ALLOC_GC) && (je32_to_cpu(rd->version) < f->highest_version)) {
+		BUG_ON(!retried);
+		D1(printk(KERN_DEBUG "jffs2_write_dirent : dirent_version %d, "
+				     "highest version %d -> updating dirent\n",
+				     je32_to_cpu(rd->version), f->highest_version));
+		rd->version = cpu_to_je32(++f->highest_version);
+		fd->version = je32_to_cpu(rd->version);
+		rd->node_crc = cpu_to_je32(crc32(0, rd, sizeof(*rd)-8));
+	}
+
 	ret = jffs2_flash_writev(c, vecs, 2, flash_ofs, &retlen,
 				 (alloc_mode==ALLOC_GC)?0:je32_to_cpu(rd->pino));
 	if (ret || (retlen != sizeof(*rd) + namelen)) {
@@ -333,8 +354,10 @@
 	raw->flash_offset |= REF_PRISTINE;
 	jffs2_add_physical_node_ref(c, raw);
 
+	spin_lock(&c->erase_completion_lock);
 	raw->next_in_ino = f->inocache->nodes;
 	f->inocache->nodes = raw;
+	spin_unlock(&c->erase_completion_lock);
 
 	if (retried) {
 		ACCT_SANITY_CHECK(c,NULL);
@@ -621,20 +644,23 @@
 
 		down(&dead_f->sem);
 
-		while (dead_f->dents) {
-			/* There can be only deleted ones */
-			fd = dead_f->dents;
-			
-			dead_f->dents = fd->next;
-			
-			if (fd->ino) {
-				printk(KERN_WARNING "Deleting inode #%u with active dentry \"%s\"->ino #%u\n",
-				       dead_f->inocache->ino, fd->name, fd->ino);
-			} else {
-				D1(printk(KERN_DEBUG "Removing deletion dirent for \"%s\" from dir ino #%u\n", fd->name, dead_f->inocache->ino));
+		if (S_ISDIR(OFNI_EDONI_2SFFJ(dead_f)->i_mode)) {
+			while (dead_f->dents) {
+				/* There can be only deleted ones */
+				fd = dead_f->dents;
+				
+				dead_f->dents = fd->next;
+				
+				if (fd->ino) {
+					printk(KERN_WARNING "Deleting inode #%u with active dentry \"%s\"->ino #%u\n",
+					       dead_f->inocache->ino, fd->name, fd->ino);
+				} else {
+					D1(printk(KERN_DEBUG "Removing deletion dirent for \"%s\" from dir ino #%u\n",
+						fd->name, dead_f->inocache->ino));
+				}
+				jffs2_mark_node_obsolete(c, fd->raw);
+				jffs2_free_full_dirent(fd);
 			}
-			jffs2_mark_node_obsolete(c, fd->raw);
-			jffs2_free_full_dirent(fd);
 		}
 
 		dead_f->inocache->nlink--;
diff -Nur linux-2.6.9-intc1/fs/jffs2/writev.c linux-2.6.9-intc1-mih1/fs/jffs2/writev.c
--- linux-2.6.9-intc1/fs/jffs2/writev.c	2004-10-18 17:54:30.000000000 -0400
+++ linux-2.6.9-intc1-mih1/fs/jffs2/writev.c	2005-03-21 21:28:41.000000000 -0500
@@ -3,11 +3,11 @@
  *
  * Copyright (C) 2001, 2002 Red Hat, Inc.
  *
- * Created by David Woodhouse <dwmw2@redhat.com>
+ * Created by David Woodhouse <dwmw2@infradead.org>
  *
  * For licensing information, see the file 'LICENCE' in this directory.
  *
- * $Id: writev.c,v 1.5 2004/07/13 08:58:25 dwmw2 Exp $
+ * $Id: writev.c,v 1.6 2004/11/16 20:36:12 dwmw2 Exp $
  *
  */
 
diff -Nur linux-2.6.9-intc1/fs/Kconfig linux-2.6.9-intc1-mih1/fs/Kconfig
--- linux-2.6.9-intc1/fs/Kconfig	2004-10-18 17:54:32.000000000 -0400
+++ linux-2.6.9-intc1-mih1/fs/Kconfig	2005-03-21 21:28:41.000000000 -0500
@@ -1107,7 +1107,7 @@
 
 config JFFS2_FS
 	tristate "Journalling Flash File System v2 (JFFS2) support"
-	select CRC32
+        select CRC32
 	depends on MTD
 	help
 	  JFFS2 is the second generation of the Journalling Flash File System
@@ -1135,21 +1135,21 @@
 	  If reporting bugs, please try to have available a full dump of the
 	  messages at debug level 1 while the misbehaviour was occurring.
 
-config JFFS2_FS_NAND
-	bool "JFFS2 support for NAND flash"
+config JFFS2_FS_WRITEBUFFER
+	bool "JFFS2 write-buffering support"
 	depends on JFFS2_FS
-	default n
+	default y
 	help
-	  This enables the support for NAND flash in JFFS2. NAND is a newer
-	  type of flash chip design than the traditional NOR flash, with
-	  higher density but a handful of characteristics which make it more
-	  interesting for the file system to use.
+	  This enables the write-buffering support in JFFS2.
 
-	  Say 'N' unless you have NAND flash.
+	  This functionality is required to support JFFS2 on the following
+	  types of flash devices:
+	    - NAND flash
+	    - NOR flash with transparent ECC
+	    - DataFlash
 
 config JFFS2_COMPRESSION_OPTIONS
 	bool "Advanced compression options for JFFS2"
-	depends on JFFS2_FS
 	default n
 	help
 	  Enabling this option allows you to explicitly choose which
diff -Nur linux-2.6.9-intc1/include/asm-arm/arch-pxa/audio.h linux-2.6.9-intc1-mih1/include/asm-arm/arch-pxa/audio.h
--- linux-2.6.9-intc1/include/asm-arm/arch-pxa/audio.h	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/include/asm-arm/arch-pxa/audio.h	2005-04-02 00:56:19.000000000 -0500
@@ -0,0 +1,16 @@
+#ifndef __ASM_ARCH_AUDIO_H__
+#define __ASM_ARCH_AUDIO_H__
+
+#include <sound/driver.h>
+#include <sound/core.h>
+#include <sound/pcm.h>
+
+typedef struct {
+        int (*startup)(snd_pcm_substream_t *, void *);
+        void (*shutdown)(snd_pcm_substream_t *, void *);
+        void (*suspend)(void *);
+        void (*resume)(void *);
+        void *priv;
+} pxa2xx_audio_ops_t;
+
+#endif
diff -Nur linux-2.6.9-intc1/include/asm-arm/arch-pxa/glencoe.h linux-2.6.9-intc1-mih1/include/asm-arm/arch-pxa/glencoe.h
--- linux-2.6.9-intc1/include/asm-arm/arch-pxa/glencoe.h	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/include/asm-arm/arch-pxa/glencoe.h	2005-04-21 20:18:25.000000000 -0400
@@ -0,0 +1,72 @@
+/*
+ *  linux/include/asm-arm/arch-pxa/glencoe.h
+ *  Author: Matthias Ihmig <m.ihmig@mytum.de>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef ASM_ARCH_GLENCOE_H
+#define ASM_ARCH_GLENCOE_H
+
+/* Glencoe specific GPIO functions and assignments*/
+
+#define GLN_GPIO_GPIO0		0	/* IN:  General purpose input */
+#define GLN_GPIO_SLEEPWAKE	1	/* IN:  Sleep/Wake button */
+
+#define GLN_GPIO_nGEM_WAKE	9	/* OUT: GEM module wake up output */
+#define GLN_GPIO_nGEM_SLEEP	10	/* IN:  GEM module sleep input, 0=module asleep, 1=module awake*/
+#define GLN_GPIO_nGEM_RST	11	/* OUT: GEM module reset, 0=in reset, 1=out of reset */
+#define GLN_GPIO_nGEM_PWR_DWN	12	/* OUT: GEM module power, 0=power off, 1=power on */
+
+#define GLN_GPIO_KP_DKIN7	13	/* IN:  Keypad Direct Key input 7*/
+#define GLN_GPIO_LCD_BRIGHTNESS	16	/* OUT: LCD Brightness output - PWM control */
+
+#define GLN_GPIO_nUSIM_CD_CPU	17	/* IN:  USIM card detect for when CPU is connected to SIM card, 0=card inserted, 1=no SIM card inserted */
+#define GLN_GPIO_MMC_PWR_ON	22	/* OUT: MMC/SD card power, 0=off, 1=on */
+#define GLN_GPIO_nMMC_CARD_DET	27	/* IN:  MMC/SD card detect input, 0=card inserted, 1=card not inserted */
+#define GLN_GPIO_nGREEN_LED	33	/* OUT: Green general purpose LED, 0=on, 1=off */
+#define GLN_GPIO_nBLUE_LED	80	/* OUT: Blue general purpose LED, 0=on, 1=off */
+#define GLN_GPIO_BL_PWR_ON	86	/* OUT: Blacklight power control, 0=off, 1=on */
+#define GLN_GPIO_LCD_PWR_ON	87	/* OUT: LCD power control, 0=off, 1=on */
+
+#define GLN_GPIO_nCF1_IRQ	100	/* IN:  Compact Flash card 1 interrupt, 0=pending, 1=no int pending */
+#define GLN_GPIO_CF1_RST	101	/* OUT: Compact Flash card 1 reset, 0=card not in reset, 1=card in reset */
+#define GLN_GPIO_CF_PWR_ON	102	/* OUT: Compact Flash power, 0=power off, 1=power on */
+#define GLN_GPIO_nCF1_CARD_DET	103	/* IN:  Compact Flash card 1 detect, 0=card inserted, 1=no card inserted */
+
+#define GLN_GPIO_nCF2_IRQ	104	/* IN:  Compact Flash card 2 interrupt, 0=pending, 1=no int pending */
+#define GLN_GPIO_CF2_RST	105	/* OUT: Compact Flash card 2 reset, 0=card not in reset, 1=card in reset */
+#define GLN_GPIO_nCF2_CARD_DET	106	/* IN:  Compact Flash card 2 detect, 0=card inserted, 1=no card inserted */
+
+#define GLN_GPIO_nAC97_INT	107	/* IN:  AC97 codec interrupt, 0=pending, 1=no int pending */
+#define GLN_GPIO_nAUDIO_PWR_DWN	108	/* OUT: Audio subsection power down, 0=powered on, 1=power off */
+
+// PWM registers for backlight
+#define GLN_BACKLIGHT_PWM_PERVAL	PWM_PERVAL0
+#define GLN_BACKLIGHT_PWM_PWDUTY	PWM_PWDUTY0
+#define GLN_BACKLIGHT_PWM_CTRL		PWM_CTRL0
+#define GLN_BACKLIGHT_PWM_MD		GPIO16_PWM0_MD
+#define GLN_BACKLIGHT_PWM_CKEN		CKEN0_PWM0
+
+
+/*
+ * LED macros
+ */
+
+#define GLN_SW_GREEN_LED_OFF (GPIO_set(GLN_GPIO_nGREEN_LED))
+#define GLN_SW_GREEN_LED_ON  (GPIO_clr(GLN_GPIO_nGREEN_LED))
+#define GLN_SW_BLUE_LED_OFF  (GPIO_set(GLN_GPIO_nBLUE_LED))
+#define GLN_SW_BLUE_LED_ON   (GPIO_clr(GLN_GPIO_nBLUE_LED))
+#define GLN_SW_BL_PWR_ON     (GPIO_set(GLN_GPIO_BL_PWR_ON))
+#define GLN_SW_BL_PWR_OFF    (GPIO_clr(GLN_GPIO_BL_PWR_ON))
+#define GLN_SW_LCD_PWR_ON    (GPIO_set(GLN_GPIO_BL_PWR_ON))
+#define GLN_SW_LCD_PWR_OFF   (GPIO_clr(GLN_GPIO_BL_PWR_ON))
+
+#define HEARTBEAT_LED_ON     GLN_SW_GREEN_LED_ON
+#define HEARTBEAT_LED_OFF    GLN_SW_GREEN_LED_OFF
+#define SYS_BUSY_LED_ON      GLN_SW_BLUE_LED_ON
+#define SYS_BUSY_LED_OFF     GLN_SW_BLUE_LED_OFF
+
+#endif
diff -Nur linux-2.6.9-intc1/include/asm-arm/arch-pxa/hardware.h linux-2.6.9-intc1-mih1/include/asm-arm/arch-pxa/hardware.h
--- linux-2.6.9-intc1/include/asm-arm/arch-pxa/hardware.h	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/include/asm-arm/arch-pxa/hardware.h	2005-02-27 12:52:01.000000000 -0500
@@ -101,4 +101,8 @@
 #include "mainstone.h"
 #endif
 
+#ifdef CONFIG_MACH_GLENCOE
+#include "glencoe.h"
+#endif
+
 #endif  /* _ASM_ARCH_HARDWARE_H */
diff -Nur linux-2.6.9-intc1/include/asm-arm/arch-pxa/irqs.h linux-2.6.9-intc1-mih1/include/asm-arm/arch-pxa/irqs.h
--- linux-2.6.9-intc1/include/asm-arm/arch-pxa/irqs.h	2004-10-18 17:53:21.000000000 -0400
+++ linux-2.6.9-intc1-mih1/include/asm-arm/arch-pxa/irqs.h	2005-02-21 22:31:55.000000000 -0500
@@ -67,10 +67,14 @@
 
 #define GPIO_2_x_TO_IRQ(x)	\
 			PXA_IRQ((x) - 2 + PXA_INTERNAL_IRQS)
+
+// x=GPIO-Pin, return IRQ-number assigned to that GPIO pin
 #define IRQ_GPIO(x)	(((x) < 2) ? (IRQ_GPIO0 + (x)) : GPIO_2_x_TO_IRQ(x))
 
 #define IRQ_TO_GPIO_2_x(i)	\
 			((i) - IRQ_GPIO(2) + 2)
+
+// IRQ i occurred, return the corresponding GPIO pin
 #define IRQ_TO_GPIO(i)	(((i) < IRQ_GPIO(2)) ? ((i) - IRQ_GPIO0) : IRQ_TO_GPIO_2_x(i))
 
 #if defined(CONFIG_PXA25x)
@@ -185,3 +189,11 @@
 #define MAINSTONE_S1_STSCHG_IRQ	MAINSTONE_IRQ(14)
 #define MAINSTONE_S1_IRQ	MAINSTONE_IRQ(15)
 
+// nAC97_IRQ = PEN_DOWN !
+#define GLENCOE_nAC97_IRQ	IRQ_GPIO(GLN_GPIO_nAC97_INT)
+#define GLENCOE_USIM_IRQ	IRQ_GPIO(GLN_GPIO_nUSIM_CD_CPU)
+#define GLENCOE_MMC_IRQ		IRQ_GPIO(GLN_GPIO_nMMC_CARD_DET)
+#define GLENCOE_S0_CD_IRQ	IRQ_GPIO(GLN_GPIO_nCF1_CARD_DET)
+#define GLENCOE_S0_IRQ		IRQ_GPIO(GLN_GPIO_nCF1_IRQ)
+#define GLENCOE_S1_CD_IRQ	IRQ_GPIO(GLN_GPIO_nCF2_CARD_DET)
+#define GLENCOE_S1_IRQ		IRQ_GPIO(GLN_GPIO_nCF2_IRQ)
